using Gtk;


public class SetSafeSock: CheckButton {
  public SetSafeSock(bool saved_option) {
    this.set_label("Enable Safe Sock");
    this.set_active(saved_option);
  }
}


public class SetSandbox: CheckButton {
  public SetSandbox(bool saved_option) {
    this.set_label("Enable Sandbox");
    this.set_active(saved_option);
  }
}


public class SetRejectPlainPort: CheckButton {
  public SetRejectPlainPort(bool saved_option) {
    this.set_label("Reject plain ports");
    this.set_active(saved_option);
  }
}


public class SetBridgeMode: ComboBoxText {
  public SetBridgeMode(int selected_option) {
    this.append_text("No Bridges");
    this.append_text("Auto Select");
    this.append_text("Manual");
    this.set_active(selected_option);
  }
  // TODO when user select manual, entry bridge addr should be enabled as well
  // TODO the parser should split values of bridge as well
}


public class SetBridgeAddress: Entry {
  public SetBridgeAddress(string saved_addr) {
    this.set_placeholder_text("Tor's bridge address");
    // TODO validate value from user with regex
    // TODO use saved value
  }
}


public class ButtonApply: Button {
  public ButtonApply() {
    this.set_label("Apply");
    this.clicked.connect(on_click_apply_options);
  }

  private void on_click_apply_options() {
    // TODO get options from all objects
    print("Apply\n");
  }
}


public class ButtonCancel: Button {
  private Dialog dialog;

  public ButtonCancel(Dialog dialog) {
    this.set_label("Cancel");
    this.dialog = dialog;
    this.clicked.connect(on_click_cancel_options);
  }

  private void on_click_cancel_options() {
    this.dialog.hide();
  }
}


public class AnonSurfDialogOptions: Dialog {
  private SetBridgeMode cmbxt_bridge_mode;
  private SetBridgeAddress entr_bridge_addr;

  private SetRejectPlainPort cbtn_set_reject_pport;
  private SetSafeSock cbtn_safe_sock_port;
  private SetSandbox cbtn_sandbox_mode;

  private ButtonApply button_apply;
  private ButtonCancel button_cancel;

  private Box box_dialog_options;

  public AnonSurfDialogOptions() {
    // TODO parse options here
    // template value to pass
    int selected_option = 0;
    string bridge_addr = "";
    bool enabled_option = true;
    // End of tmp values

    cmbxt_bridge_mode = new SetBridgeMode(selected_option);
    entr_bridge_addr = new SetBridgeAddress(bridge_addr);

    cbtn_safe_sock_port = new SetSafeSock(enabled_option);
    cbtn_sandbox_mode = new SetSandbox(enabled_option);
    cbtn_set_reject_pport = new SetRejectPlainPort(enabled_option);

    button_apply = new ButtonApply();
    button_cancel = new ButtonCancel(this);

    this.set_title("AnonSurf Options");
    this.set_icon_name("preferences-desktop");
    this.set_resizable(false);

    var content_area = this.get_content_area(); // FIXME: c source complains about incompatible pointer
    dialog_options_create_layout();
    content_area.add(box_dialog_options);
  }

  private void dialog_options_create_option_layout() {
    var box_combo_box_area = new Box(Orientation.VERTICAL, 3);
    //  box_combo_box_area.pack_start(cmbxt_plain_port, false, true, 3);
    box_combo_box_area.pack_start(cmbxt_bridge_mode, false, true, 3);
    box_combo_box_area.pack_start(entr_bridge_addr, false, true, 3);

    var box_check_button_area = new Box(Orientation.VERTICAL, 3);
    box_check_button_area.pack_start(cbtn_set_reject_pport, false, true, 3);
    box_check_button_area.pack_start(cbtn_safe_sock_port, false, true, 3);
    box_check_button_area.pack_start(cbtn_sandbox_mode, false, true, 3);

    var box_option_area = new Box(Orientation.HORIZONTAL, 3);
    box_option_area.pack_start(box_combo_box_area, false, true, 3);
    box_option_area.pack_start(box_check_button_area, false, true, 3);

    box_dialog_options.pack_start(box_option_area, false, true, 3);
  }

  private void dialog_options_add_button_layout() {
    var box_button_area = new Box(Orientation.HORIZONTAL, 3);

    box_button_area.pack_start(button_apply, false, true, 3);
    box_button_area.pack_end(button_cancel, false, true, 3);

    box_dialog_options.pack_end(box_button_area, true, true, 3);
  }

  private void dialog_options_create_layout() {
    box_dialog_options = new Box(Orientation.VERTICAL, 3);
    dialog_options_create_option_layout();
    dialog_options_add_button_layout();
  }

  public void invoke() {
    // TODO parse saved settings here
    this.show_all();
    this.run();
    this.hide();
  }
}
